local mod = ...



-- Upgrade: Methods -------------------------------------------------------------------------------------

-- Assets
mod:registerAssetId("models/Upgrade2.fbx/Prefab/Brewery.Part", "PREFAB_UPGRADE_BREWERY" )

-- Grounding
mod:registerPrefabComponent("PREFAB_UPGRADE_BREWERY", { DataType = "COMP_GROUNDED", SetOrientation = true })

-- Assemblage
mod:registerAsset({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_UPGRADE_BREWERY_ASSEMBLAGE",
	Name = "BUILDING_PART_UPGRADE_METHODS_NAME",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { "PREFAB_UPGRADE_BREWERY" },
		MandatoryBuildingPartList = {
			{ BuildingPart = "CART_PART", OptionalAttachNodeString = "Attach_Minor.003" }, -- from Fantasy Decorations
			{ BuildingPart = "BARREL_LARGE_PART", OptionalAttachNodeString = "Attach_Minor.004" }, -- from Fantasy Decorations
		}
	},
})

-- Random
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_UPGRADE_BREWERY",
    Name = "BUILDING_PART_UPGRADE_METHODS_NAME",
    Category = "UPGRADE",
    AssetBuildingFunction = "BUILDING_FUNCTION_UPGRADE_TOOLS",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
        RandomPartList = {
            "BUILDING_PART_UPGRADE_BREWERY_ASSEMBLAGE",
        },
        MiniatureConfig = {
            ClipUnderGround = true,
            GroupHeight = 0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0,
            CameraPitchOffset = 0,
        },
    },
    HasMaximumInstancePerBuilding = true,
    MaximumInstancePerBuilding = 1,
    BuildingZone = {
        -- ZoneEntryList = {
        --     {
        --         Polygon = polygon.createRectangle( {3.0, 1.9}, {0, 0} ),
        --         Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true },
        --     },
        -- },
    },
    Cost = UpgradeCostMethods,
})



-- Name for single vanilla building parts
mod:overrideAsset({
    Id = "BUILDING_PART_BREWERY",
    Name = "BREWERY",
})



-- Add to Building
mod:overrideAsset({
    Id = "BUILDING_BREWERY",
    BuildingPartSetList = {
        Action = "APPEND",
        {
            Name = "BUILDING_PART_SETLIST_UPGRADE",
            BuildingPartList = {
                "BUILDING_PART_UPGRADE_BREWERY",
            },
        },
    },
})


if foundation.isModLoaded("f252f14d-ca1d-4d02-97ca-46581d4b567d") then

    mod:overrideAsset({
        Id = "BUILDING_CIDERPRESS",
        BuildingPartSetList = {
            Action = "APPEND",
            {
                Name = "BUILDING_PART_SETLIST_UPGRADE",
                BuildingPartList = {
                    "BUILDING_PART_UPGRADE_BREWERY",
                },
            },
        },
    })

end -- Orchard mod
