local mod = ...



-- Upgrade: Methods -------------------------------------------------------------------------------------

-- Assets
mod:registerAssetId("models/Upgrade2.fbx/Prefab/Charcoal.Part", "PREFAB_UPGRADE_CHARCOAL" )

-- Grounding
mod:registerPrefabComponent("PREFAB_UPGRADE_CHARCOAL", { DataType = "COMP_GROUNDED", SetOrientation = true })
for i = 26, 27 do
    mod:registerPrefabComponent("models/Upgrade2.fbx/Prefab/Charcoal.Part/Attach_Minor." .. string.sub("000" .. i, -3), { DataType = "COMP_GROUNDED" })
end

-- Assemblage
mod:registerAsset({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_UPGRADE_CHARCOAL_ASSEMBLAGE",
	Name = "BUILDING_PART_UPGRADE_METHODS_NAME",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { "PREFAB_UPGRADE_CHARCOAL" },
		MandatoryBuildingPartList = {
			{ BuildingPart = "LOGS_LARGE2_PART", OptionalAttachNodeString = "Attach_Minor.026" }, -- from Fantasy Decorations
			{ BuildingPart = "LOGS_LARGE3_PART", OptionalAttachNodeString = "Attach_Minor.027" }, -- from Fantasy Decorations
		},
	},
})

-- Random
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_UPGRADE_CHARCOAL",
    Name = "BUILDING_PART_UPGRADE_METHODS_NAME",
    Category = "UPGRADE",
    AssetBuildingFunction = "BUILDING_FUNCTION_UPGRADE_TOOLS",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
        RandomPartList = {
            "BUILDING_PART_UPGRADE_CHARCOAL_ASSEMBLAGE",
        },
        MiniatureConfig = {
            ClipUnderGround = true,
            GroupHeight = 0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0,
            CameraPitchOffset = 0,
        },
    },
    HasMaximumInstancePerBuilding = true,
    MaximumInstancePerBuilding = 1,
    BuildingZone = {
        ZoneEntryList = {
            {
                Polygon = polygon.createRectangle( {3.5, 3.5}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true },
            },
        },
    },
    Cost = UpgradeCostMethods,
})



-- Name for single vanilla building parts
mod:overrideAsset({
    Id = "BUILDING_PART_COAL_HUT",
    Name = "COAL_HUT",
})



-- Add to Building
mod:overrideAsset({
    Id = "BUILDING_COAL_HUT",
    BuildingPartSetList = {
        Action = "APPEND",
        {
            Name = "BUILDING_PART_SETLIST_UPGRADE",
            BuildingPartList = {
                "BUILDING_PART_UPGRADE_CHARCOAL",
            },
        },
    },
})
