local mod = ...



-- Upgrade: Fodder -------------------------------------------------------------------------------------

-- Assets
mod:registerAssetId("models/Upgrade1.fbx/Prefab/DairyFarm.Feed.Part", "PREFAB_UPGRADE_DAIRY_FARM" )
mod:registerAssetId("models/Upgrade1.fbx/Prefab/DairyFarm.Feed.Part.Constr", "PREFAB_UPGRADE_DAIRY_FARM_CONSTR" )

-- Part
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_UPGRADE_DAIRY_FARM",
    Name = "BUILDING_PART_UPGRADE_FODDER_NAME",
    Category = "UPGRADE",
    AssetBuildingFunction = "BUILDING_FUNCTION_UPGRADE_FODDER",
    ConstructionVisual = "PREFAB_UPGRADE_DAIRY_FARM_CONSTR",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_UPGRADE_DAIRY_FARM",
        MiniatureConfig = {
            ClipUnderGround = true,
            GroupHeight = 0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0,
            CameraPitchOffset = 0.0
        },
    },
    HasMaximumInstancePerBuilding = true,
    MaximumInstancePerBuilding = 1,
    BuildingZone = {
        ZoneEntryList = {
            {
                Polygon = polygon.createCircle( 1.9, {0.0, 0.0}, 16 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true },
            },
        },
    },
    Cost = UpgradeCostFodder,
})



-- Name for single vanilla building parts
mod:overrideAsset({
    Id = "BUILDING_PART_DAIRY_FARM",
    Name = "DAIRY_FARM",
})



-- Add to Building ----------------------------------------------------------------------------
mod:overrideAsset({
    Id = "BUILDING_DAIRY_FARM",
    BuildingPartSetList = {
        Action = "APPEND",
        {
            Name = "BUILDING_PART_SETLIST_UPGRADE",
            BuildingPartList = {
                "BUILDING_PART_UPGRADE_DAIRY_FARM",
            },
        },
    },
})

mod:overrideAsset({
    Id = "BUILDING_SHEEP_FARM",
    BuildingPartSetList = {
        Action = "APPEND",
        {
            Name = "BUILDING_PART_SETLIST_UPGRADE",
            BuildingPartList = {
                "BUILDING_PART_UPGRADE_DAIRY_FARM",
            },
        },
    },
})

if (foundation.isModLoaded("f6361b64-05d3-4ab5-a2db-b3b60dc4d307")) then -- Livestock Farms mod

    mod:overrideAsset({
        Id = "BUILDING_LIVESTOCKFARM_CATTLE",
        BuildingPartSetList = {
            Action = "APPEND",
            {
                Name = "BUILDING_PART_SETLIST_UPGRADE",
                BuildingPartList = {
                    "BUILDING_PART_UPGRADE_DAIRY_FARM",
                },
            },
        },
    })

    mod:overrideAsset({
        Id = "BUILDING_LIVESTOCKFARM_PIG",
        BuildingPartSetList = {
            Action = "APPEND",
            {
                Name = "BUILDING_PART_SETLIST_UPGRADE",
                BuildingPartList = {
                    "BUILDING_PART_UPGRADE_DAIRY_FARM",
                },
            },
        },
    })

    mod:overrideAsset({
        Id = "BUILDING_LIVESTOCKFARM_GOAT",
        BuildingPartSetList = {
            Action = "APPEND",
            {
                Name = "BUILDING_PART_SETLIST_UPGRADE",
                BuildingPartList = {
                    "BUILDING_PART_UPGRADE_DAIRY_FARM",
                },
            },
        },
    })

    mod:overrideAsset({
        Id = "BUILDING_LIVESTOCKFARM_SHEEP",
        BuildingPartSetList = {
            Action = "APPEND",
            {
                Name = "BUILDING_PART_SETLIST_UPGRADE",
                BuildingPartList = {
                    "BUILDING_PART_UPGRADE_DAIRY_FARM",
                },
            },
        },
    })

end