local mod = ...



-- Upgrade: Fodder -------------------------------------------------------------------------------------

-- Assets
mod:registerAssetId("models/Upgrade1.fbx/Prefab/PoultryFarm.Feed.Part", "PREFAB_UPGRADE_POULTRYFARM" )
mod:registerAssetId("models/Upgrade1.fbx/Prefab/PoultryFarm.Feed.Part.Constr", "PREFAB_UPGRADE_POULTRYFARM_CONSTR" )

-- Part
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_UPGRADE_POULTRYFARM",
    Name = "BUILDING_PART_UPGRADE_HOUSING_NAME",
    Category = "UPGRADE",
    AssetBuildingFunction = "BUILDING_FUNCTION_UPGRADE_FODDER",
    ConstructionVisual = "PREFAB_UPGRADE_POULTRYFARM_CONSTR",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_UPGRADE_POULTRYFARM",
        MiniatureConfig = {
            ClipUnderGround = true,
            GroupHeight = 0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0,
            CameraPitchOffset = 0.0
        },
    },
    HasMaximumInstancePerBuilding = true,
    MaximumInstancePerBuilding = 1,
    BuildingZone = {
        ZoneEntryList = {
            {
                Polygon = polygon.createRectangle( {2.1, 2.1}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true },
            },
        },
    },
    Cost = UpgradeCostHousing,
})



-- Add to Building ----------------------------------------------------------------------------
if (foundation.isModLoaded("c8b63172-5b6d-45eb-9fab-a40c8ecd9947")) then -- Vegetable and Poultry Farms mod

    mod:overrideAsset({
        Id = "BUILDING_POULTRY",
        BuildingPartSetList = {
            Action = "APPEND",
            {
                Name = "BUILDING_PART_SETLIST_UPGRADE",
                BuildingPartList = {
                    "BUILDING_PART_UPGRADE_POULTRYFARM",
                },
            },
        },
    })

end