local mod = ...



-- Upgrade: Methods -------------------------------------------------------------------------------------

-- Assets
mod:registerAssetId("models/Upgrade2.fbx/Prefab/Sawmill.Part", "PREFAB_UPGRADE_SAWMILL" )

-- Grounding
for i = 34, 35 do
    mod:registerPrefabComponent("models/Upgrade2.fbx/Prefab/Sawmill.Part/Attach_Minor." .. string.sub("000" .. i, -3), { DataType = "COMP_GROUNDED" })
end

-- Assemblage
mod:registerAsset({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_UPGRADE_SAWMILL_ASSEMBLAGE",
	Name = "BUILDING_PART_UPGRADE_TOOLS_NAME",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { "PREFAB_UPGRADE_SAWMILL" },
		MandatoryBuildingPartList = {
			{ BuildingPart = "TOOLS_RACK_PART", OptionalAttachNodeString = "Attach_Minor.034" }, -- from Fantasy Decorations
			{ BuildingPart = "TOOLS_RACK_PART", OptionalAttachNodeString = "Attach_Minor.035" }, -- from Fantasy Decorations
		},
	},
})

-- Random
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_UPGRADE_SAWMILL",
    Name = "BUILDING_PART_UPGRADE_TOOLS_NAME",
    Category = "UPGRADE",
    AssetBuildingFunction = "BUILDING_FUNCTION_UPGRADE_TOOLS",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
        RandomPartList = {
            "BUILDING_PART_UPGRADE_SAWMILL_ASSEMBLAGE",
        },
        MiniatureConfig = {
            ClipUnderGround = true,
            GroupHeight = 0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0,
            CameraPitchOffset = 0,
        },
    },
    HasMaximumInstancePerBuilding = true,
    MaximumInstancePerBuilding = 1,
    BuildingZone = {
        ZoneEntryList = {
            {
                Polygon = polygon.createRectangle( {2.5, 2.5}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true },
            },
        },
    },
    Cost = UpgradeCostMachinery,
})



-- Name for single vanilla building parts
mod:overrideAsset({
    Id = "BUILDING_PART_SAWMILL",
    Name = "SAWMILL",
})



-- Add to Building
mod:overrideAsset({
    Id = "BUILDING_SAWMILL",
    BuildingPartSetList = {
        Action = "APPEND",
        {
            Name = "BUILDING_PART_SETLIST_UPGRADE",
            BuildingPartList = {
                "BUILDING_PART_UPGRADE_SAWMILL",
            },
        },
    },
})
