local mod = ...



-- Upgrade: Methods -------------------------------------------------------------------------------------

-- Assets
mod:registerAssetId("models/Upgrade2.fbx/Prefab/Stonecutter.Part", "PREFAB_UPGRADE_STONECUTTER" )

-- Grounding
for i = 24, 25 do
    mod:registerPrefabComponent("models/Upgrade2.fbx/Prefab/Stonecutter.Part/Attach_Minor." .. string.sub("000" .. i, -3), { DataType = "COMP_GROUNDED" })
end

-- Assemblage
mod:registerAsset({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_UPGRADE_STONECUTTER_ASSEMBLAGE",
	Name = "BUILDING_PART_UPGRADE_METHODS_NAME",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { "PREFAB_UPGRADE_STONECUTTER" },
		MandatoryBuildingPartList = {
			{ BuildingPart = "TOOLS_RACK_PICKS_PART", OptionalAttachNodeString = "Attach_Minor.024" }, -- from Fantasy Decorations
			{ BuildingPart = "TOOLS_RACK_PICKS_PART", OptionalAttachNodeString = "Attach_Minor.025" }, -- from Fantasy Decorations
		},
	},
})

-- Random
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_UPGRADE_STONECUTTER",
    Name = "BUILDING_PART_UPGRADE_METHODS_NAME",
    Category = "UPGRADE",
    AssetBuildingFunction = "BUILDING_FUNCTION_UPGRADE_TOOLS",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
        RandomPartList = {
            "BUILDING_PART_UPGRADE_STONECUTTER_ASSEMBLAGE",
        },
        MiniatureConfig = {
            ClipUnderGround = true,
            GroupHeight = 0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0,
            CameraPitchOffset = 0,
        },
    },
    HasMaximumInstancePerBuilding = true,
    MaximumInstancePerBuilding = 1,
    BuildingZone = {
        ZoneEntryList = {
            {
                Polygon = polygon.createRectangle( {2.5, 2.5}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true },
            },
        },
    },
    Cost = UpgradeCostMachinery,
})



-- Name for single vanilla building parts
mod:overrideAsset({
    Id = "BUILDING_PART_STONECUTTER_CAMP",
    Name = "STONECUTTER_CAMP",
})

mod:overrideAsset({
    Id = "BUILDING_PART_STONEMASON",
    Name = "STONEMASON_HUT",
})



-- Add to Building
mod:overrideAsset({
    Id = "BUILDING_STONECUTTER_CAMP",
    BuildingPartSetList = {
        Action = "APPEND",
        {
            Name = "BUILDING_PART_SETLIST_UPGRADE",
            BuildingPartList = {
                "BUILDING_PART_UPGRADE_STONECUTTER",
            },
        },
    },
})

mod:overrideAsset({
    Id = "BUILDING_QUARRY_STONE_DEPOSIT",
    BuildingPartSetList = {
        Action = "APPEND",
        {
            Name = "BUILDING_PART_SETLIST_UPGRADE",
            BuildingPartList = {
                "BUILDING_PART_UPGRADE_STONECUTTER",
            },
        },
    },
})

mod:overrideAsset({
    Id = "BUILDING_STONEMASON_HUT",
    BuildingPartSetList = {
        Action = "APPEND",
        {
            Name = "BUILDING_PART_SETLIST_UPGRADE",
            BuildingPartList = {
                "BUILDING_PART_UPGRADE_STONECUTTER",
            },
        },
    },
})
