local mod = ...



-- Upgrade: Methods -------------------------------------------------------------------------------------

-- Assets
mod:registerAssetId("models/Upgrade2.fbx/Prefab/Tailor.Part", "PREFAB_UPGRADE_TAILOR_WORKSHOP" )

-- Grounding
mod:registerPrefabComponent("PREFAB_UPGRADE_TAILOR_WORKSHOP", { DataType = "COMP_GROUNDED", SetOrientation = true })

-- Assemblage
mod:registerAsset({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_UPGRADE_TAILOR_WORKSHOP_ASSEMBLAGE",
	Name = "BUILDING_PART_UPGRADE_MACHINERY_NAME",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { "PREFAB_UPGRADE_TAILOR_WORKSHOP" },
		MandatoryBuildingPartList = {
			{ BuildingPart = "CART_PART", OptionalAttachNodeString = "Attach_Minor.012" }, -- from Fantasy Decorations
			{ BuildingPart = "SPOOLS_PART", OptionalAttachNodeString = "Attach_Minor.013" }, -- from Fantasy Decorations
		}
	},
})

-- Random
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_UPGRADE_TAILOR_WORKSHOP",
    Name = "BUILDING_PART_UPGRADE_MACHINERY_NAME",
    Category = "UPGRADE",
    AssetBuildingFunction = "BUILDING_FUNCTION_UPGRADE_TOOLS",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
        RandomPartList = {
            "BUILDING_PART_UPGRADE_TAILOR_WORKSHOP_ASSEMBLAGE",
        },
        MiniatureConfig = {
            ClipUnderGround = true,
            GroupHeight = 0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0,
            CameraPitchOffset = 0,
        },
    },
    HasMaximumInstancePerBuilding = true,
    MaximumInstancePerBuilding = 1,
    BuildingZone = {
        -- ZoneEntryList = {
        --     {
        --         Polygon = polygon.createRectangle( {1.9, 3.0}, {0, 0} ),
        --         Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true },
        --     },
        -- },
    },
    Cost = UpgradeCostMachinery,
})



-- Name for single vanilla building parts
mod:overrideAsset({
    Id = "BUILDING_PART_TAILOR_WORKSHOP",
    Name = "TAILORS_WORKSHOP",
})



-- Add to Building
mod:overrideAsset({
    Id = "BUILDING_TAILOR_WORKSHOP",
    BuildingPartSetList = {
        Action = "APPEND",
        {
            Name = "BUILDING_PART_SETLIST_UPGRADE",
            BuildingPartList = {
                "BUILDING_PART_UPGRADE_TAILOR_WORKSHOP",
            },
        },
    },
})
