local mod = ...



-- Upgrade: Wheat Production -------------------------------------------------------------------------------------

-- Assets
mod:registerAssetId("models/Upgrade1.fbx/Prefab/WheatFarm.Tools.Part", "PREFAB_UPGRADE_WHEAT_FARM_TOOLS" )

-- Grounding
for i = 1, 2 do
    mod:registerPrefabComponent("models/Upgrade1.fbx/Prefab/WheatFarm.Tools.Part/Attach_Minor." .. string.sub("000" .. i, -3), { DataType = "COMP_GROUNDED" })
end

-- Assemblage
mod:registerAsset({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_UPGRADE_WHEAT_FARM_PRODUCTION_TOOLS_ASSEMBLAGE",
	Name = "BUILDING_PART_UPGRADE_TOOLS_NAME",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { "PREFAB_UPGRADE_WHEAT_FARM_TOOLS" },
		MandatoryBuildingPartList = {
			{ BuildingPart = "TOOLS_BARREL_FARM_PART", OptionalAttachNodeString = "Attach_Minor.001" }, -- from Fantasy Decorations
			{ BuildingPart = "TOOLS_RACK_FARM_PART", OptionalAttachNodeString = "Attach_Minor.002" }, -- from Fantasy Decorations
		}
	},
})

-- Random
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_UPGRADE_WHEAT_FARM_PRODUCTION_TOOLS",
    Name = "BUILDING_PART_UPGRADE_TOOLS_NAME",
    Category = "UPGRADE",
    AssetBuildingFunction = "BUILDING_FUNCTION_UPGRADE_TOOLS",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
        RandomPartList = {
            "BUILDING_PART_UPGRADE_WHEAT_FARM_PRODUCTION_TOOLS_ASSEMBLAGE",
        },
        MiniatureConfig = {
            ClipUnderGround = true,
            GroupHeight = 0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0,
            CameraPitchOffset = 0.0
        },
    },
    HasMaximumInstancePerBuilding = true,
    MaximumInstancePerBuilding = 1,
    BuildingZone = {
        ZoneEntryList = {
            {
                Polygon = polygon.createRectangle( {4.0, 2.25}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true },
            },
        },
    },
    Cost = UpgradeCostTools,
})



-- Upgrade: Wheat Workers -------------------------------------------------------------------------------------

-- Assets
mod:registerAssetId("models/Upgrade1.fbx/Prefab/WheatFarm.Workers.Part", "PREFAB_UPGRADE_WHEAT_FARM_WORKERS" )

-- Building Part
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_UPGRADE_WHEAT_FARM_WORKERS",
    Name = "BUILDING_PART_UPGRADE_WORKERS_NAME",
    Category = "UPGRADE",
    AssetBuildingFunction = "BUILDING_FUNCTION_WHEAT_FARM",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_UPGRADE_WHEAT_FARM_WORKERS",
        MiniatureConfig = {
            ClipUnderGround = true,
            GroupHeight = 0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0,
            CameraPitchOffset = 0.0
        },
    },
    HasMaximumInstancePerBuilding = true,
    MaximumInstancePerBuilding = 2,
    BuildingZone = {
        ZoneEntryList = {
            {
                Polygon = polygon.createCircle( 1.3, {0, 0}, 10 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true }
            },
        },
    },
    Cost = UpgradeCostField,
})



-- Upgrade: Add Thatch as Output -------------------------------------------------------------------------------------

-- Assets
mod:registerAssetId("models/Upgrade1.fbx/Prefab/WheatFarm.Thatch.Part", "PREFAB_UPGRADE_WHEAT_FARM_THATCH" )

-- Grounding
mod:registerPrefabComponent("models/Upgrade1.fbx/Prefab/WheatFarm.Thatch.Part/Thatch.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Upgrade1.fbx/Prefab/WheatFarm.Thatch.Part/Thatch.002", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Upgrade1.fbx/Prefab/WheatFarm.Thatch.Part/Thatch.003", {DataType = "COMP_GROUNDED"})

-- Building Function
mod:registerAsset({
    DataType = "BUILDING_FUNCTION",
    Id = "BUILDING_FUNCTION_UPGRADE_THATCH",
    Name = "BUILDING_PART_THATCH_NAME",
    GameRuleModifierList = {
        {
            DataType = "GAME_RULE_MODIFIER_WORKPLACE_RECIPE",
            ResourceProducedToAdd = {
                {
                    Resource = "RESOURCE_THATCH",
                    Quantity = 1,
                },
            },
        },
    },
})

-- Building Part
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_UPGRADE_WHEAT_FARM_THATCH",
    Name = "BUILDING_PART_THATCH_NAME",
    Category = "UPGRADE",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_UPGRADE_WHEAT_FARM_THATCH",
        MiniatureConfig = {
            ClipUnderGround = true,
            GroupHeight = 0.0,
            CameraPosition = { 0, 0.6, -15 },
            OrientationOffset = 0.0,
            CameraPitchOffset = 20.0
            },
    },
    HasMaximumInstancePerBuilding = true,
    MaximumInstancePerBuilding = 1,
    AssetBuildingFunction = "BUILDING_FUNCTION_UPGRADE_THATCH",
    BuildingZone = {
        ZoneEntryList = {
            {
                Polygon = polygon.createCircle( 1.8, {0, 0}, 10 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true }
            },
        }
    },
    Cost = UpgradeCostField,
})



-- Name for single vanilla building parts
mod:overrideAsset({
    Id = "BUILDING_PART_WHEAT_FARM",
    Name = "WHEAT_FARM",
})


-- mod:registerAsset({
--     DataType = "UNLOCKABLE_BUILDING_PART_LIST",
--     Id = "UNLOCKABLE_" .. name,
--     Name = "UNLOCK_NEW_PARTS_FOR_X",
--     Description = "UNLOCK_NEW_PARTS_FOR_X_DESC",
--     AssetBuilding = name,
--     BuildingPartSetList = {
--         {
--             Name = "BUILDING_PART_SETLIST_UPGRADE",
--             BuildingPartList = {
--                 "BUILDING_PART_UPGRADE_" .. name,
--             },
--         },
--     },
--     EstateInfluenceCostList = {
--         {
--             Estate = idEstate,
--             Quantity = qtyInfluence,
--         },
--     },
--     PrerequisiteUpgrades = listPrereq,
--     IsRecurrent = false,
--     IsComingSoon = false,
--     DaysBeforeBuyingAgain = 0,
--     UnlockableImage = nil,
-- })



-- Add to building
mod:overrideAsset({
    Id = "BUILDING_WHEAT_FARM",
    BuildingPartSetList = {
        Action = "APPEND",
        {
            Name = "BUILDING_PART_SETLIST_UPGRADE",
            BuildingPartList = {
                "BUILDING_PART_UPGRADE_WHEAT_FARM_PRODUCTION_TOOLS",
                "BUILDING_PART_UPGRADE_WHEAT_FARM_WORKERS",
                "BUILDING_PART_UPGRADE_WHEAT_FARM_THATCH",
            },
        },
    },
})
