local mod = ...



-- Upgrade: Methods -------------------------------------------------------------------------------------

-- Assets
mod:registerAssetId("models/Upgrade2.fbx/Prefab/Woodcutter.Part", "PREFAB_UPGRADE_WOODCUTTER" )

-- Grounding
for i = 20, 23 do
    mod:registerPrefabComponent("models/Upgrade2.fbx/Prefab/Woodcutter.Part/Attach_Minor." .. string.sub("000" .. i, -3), { DataType = "COMP_GROUNDED" })
end

-- Assemblage
mod:registerAsset({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_UPGRADE_WOODCUTTER_ASSEMBLAGE",
	Name = "BUILDING_PART_UPGRADE_METHODS_NAME",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { "PREFAB_UPGRADE_WOODCUTTER" },
		MandatoryBuildingPartList = {
			{ BuildingPart = "FIREWOOD_COVERED1", OptionalAttachNodeString = "Attach_Minor.020" }, -- from Fantasy Decorations
			{ BuildingPart = "FIREWOOD1_PART", OptionalAttachNodeString = "Attach_Minor.021" }, -- from Fantasy Decorations
			{ BuildingPart = "FIREWOOD_COVERED2_PART", OptionalAttachNodeString = "Attach_Minor.022" }, -- from Fantasy Decorations
			{ BuildingPart = "FIREWOOD2_PART", OptionalAttachNodeString = "Attach_Minor.023" }, -- from Fantasy Decorations
		},
	},
})

-- Random
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_UPGRADE_WOODCUTTER",
    Name = "BUILDING_PART_UPGRADE_METHODS_NAME",
    Category = "UPGRADE",
    AssetBuildingFunction = "BUILDING_FUNCTION_UPGRADE_TOOLS",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
        RandomPartList = {
            "BUILDING_PART_UPGRADE_WOODCUTTER_ASSEMBLAGE",
        },
        MiniatureConfig = {
            ClipUnderGround = true,
            GroupHeight = 0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0,
            CameraPitchOffset = 0,
        },
    },
    HasMaximumInstancePerBuilding = true,
    MaximumInstancePerBuilding = 1,
    BuildingZone = {
        ZoneEntryList = {
            {
                Polygon = polygon.createRectangle( {3, 3}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true },
            },
        },
    },
    Cost = UpgradeCostField,
})



-- Name for single vanilla building parts
mod:overrideAsset({
    Id = "BUILDING_PART_WOODCUTTER_CAMP",
    Name = "LUMBER_CAMP",
})



-- Add to Building
mod:overrideAsset({
    Id = "BUILDING_WOODCUTTER_CAMP",
    BuildingPartSetList = {
        Action = "APPEND",
        {
            Name = "BUILDING_PART_SETLIST_UPGRADE",
            BuildingPartList = {
                "BUILDING_PART_UPGRADE_WOODCUTTER",
            },
        },
    },
})
